var express = require('express');
var app = express();
var tsp = require('tspsolver');
var chalk = require('chalk');
var exeq = require('lego-exeq');
var bodyParser = require('body-parser');
var request = require('request');
var cp = require('child_process');
var clear = require('clear');
const fs = require('fs');
var config = require('./config.json');
var roadRoute = [config.headquarter_generic];
var send = {};
var addresses = [];
var options = {};
var port = 3000;
var mute = require('mute');
var Spinner = require('cli-spinner').Spinner;
var spinner = new Spinner('%s Calculating Optimal RoundTrip  | ');
spinner.setSpinnerString('|/-\\');

app.use(express.static(__dirname + '/'));
app.use(function(req, res, next) {
    res.setHeader('Content-Type', 'application/JSON');
    res.header("Access-Control-Allow-Origin", "*");
    res.header("Access-Control-Allow-Origin", "*");
    res.header("Access-Control-Allow-Headers", "*");
    res.header("Access-Control-Allow-Methods", "*");
    next();
});

//DATA PARSING
app.use(bodyParser.json());
app.use(bodyParser.urlencoded({ extended: true }));



var options = {
    center: [config.center_latitude, config.center_longitude],
    zoom: config.zoom_level        
};



//ADDRESSES RECEIVER
app.all('/api/route-solver', function(req, res) {

    //INIT FORM OBJECT
    var form = {};

    //READ FORM ADDRESS VALUE (VERIFICATION PURPOSES)
    if (req.body.address === '') {
        form.obj = '1150 Golf Club Rd, Hawkesbury, ON';
    } else {
        form.obj = req.body.address;
    }


    //READ FORM NAME VALUE (VERIFICATION PURPOSES)
    if (req.body.firstname === '' || req.body.lastname === ''){
        form.name = 'John Doe';
    } else {
        form.name = req.body.firstname + ' ' + req.body.lastname;
    }
    //FILL ROUTE ARRAY
    roadRoute.push(form.obj);

    if (req.method == "POST") {

        //TIMESTAMP
        var timestamp = new Date();
        
        //DEFAULT VALUES
        
                var client = {
                    name: form.name,
                    address: form.obj,
                    phone: req.body.phone || '6135555555',
                    email: req.body.email || 'you@example.com',
                    paid: true
                }
        
        
        //FILL ADDRESS ARRAY
        addresses.push(form.obj);

        //API CONSOLE LOG
        console.log('    ');
        console.log(chalk.bgWhite.red(' RECEIVED: ') + ' ' + form.obj + '  |  ' + chalk.bgGreen.black(timestamp));



        // NEED DATABASE PUSH HERE

            //DATABASE PROMISE RETURN                  
                //  IF PROMISE SOLVED   |
                //                      V


                    //REQUEST RESPONSE
                    res.send(
                        '[ADDED] --> ' + form.obj + '  ' + ' \n \n' +
                        'Name: ' + client.name + ' ' + ' ' +
                        'Phone: ' + client.phone + ' ' + ' ' +
                        'Email: ' + client.email + ' ' + ' ' +
                        'Paid: ' + client.paid + ' \n \n' +
                        'Date: ' + timestamp
                    );
        

                //  IF PROMISE REJECTED  |
                //                       V


                    // ERROR HANDLING + RESPONSE CONSTRUCTOR


    }

});

var countSingle = 0;
app.get('/api/route-gen', function(req, res) {

    if(countSingle < 1) {
    console.log('    ');
    spinner.start();
    countSingle = countSingle + 1;
    };

    for (var i=0;i<roadRoute.length;i++) {
        //console.log("Adding address '"+roadRoute[i]+"'");
        tsp.addAddress(roadRoute[i]);
        
    }
    
    tsp.solveRoundTrip(function() {

        var embed_uri = tsp.createGoogleLink(true);
        var map_uri   = tsp.createGoogleLink();
        send = {
            'addresses': addresses,
            'embed_uri': embed_uri,
            'map_uri' :  map_uri,
            'map_route': roadRoute
        };
        var time = 500;
        var w = 0;
        var counterTimeout = send.map_route.length - 1;
        
        function routeSolved() {
            goCaliss('Finished √');
        }
        function goCaliss(y) {
            if(y == 'Finished √') {
                spinner.text = y;
                setTimeout(function() {
                    spinner.stop();
                    console.log('   ');
                    console.log('   ');
                    
                        console.log('   --- Route Directions ---   ');
                        console.log('   ');
                        console.log(chalk.bgGreen.white('START\(' + 0 + '\):') + '[' + roadRoute[0] + ']');
                        console.log('   ');
                        listStops();
                        y = '';
                        var endVar = counterTimeout + 2;
                        console.log('   ');
                        console.log(chalk.bgRed.white('END  \(' + endVar + '\):') + '[' + roadRoute[0] + ']');
                               

                        function terminateProcess(statement){
                            if(statement === true) {
                                var unmuteErr = mute(process.stderr);
 
                                    console.error('bar'); // doesn't print 'bar'
                                    process.exit(2);
                                    unmuteErr();
                                    
                                    console.error('bar'); // prints 'bar'
                            } 
                        }

                  setTimeout(terminateProcess(true), 2000);

                }, calcTime + 1600);
            }
            setTimeout(function(){

                if(w == counterTimeout){
                    routeSolved();
                    
                };

                w = w + 1;
                spinner.text = y;
                 }, time);
            
                 time = time + 500;
                
                };
            
      


      

     
        send.map_route.push(roadRoute[0]);
        var destinations = [];
        var directions = [];
        var i = 2;
        var u = 1;
    
      
        var calc = roadRoute.length / 2;
       
        var arrO = 0;
        var arrP = 0;
        calc = Math.floor(calc);
        var reste = calc - roadRoute.length;
        //console.log('split: ' + calc + ' | diff: ' + reste);
        var restant = calc + reste;
        restant = restant * -1;

            for (i = 0; i < calc; i++) { 
                var u = i + 1;
                var j = u + 1;
                var int1 = roadRoute[u];
                var int2 = roadRoute[j];
                int1 = int1 + 1;
                destinations.push('STOP' + u + ':' + '[' + int1 + ']');
                destinations.push('STOP' + j + ':' + '[' + int2 + ']');
                u++;
                j++;
                i++;
            };

            var o = -1;
            var p = 0;
            var much = destinations.length + 3;
            

            for(i = 0; i <= much; i++) {
                o++;
                p++;
                o++;
                p++;

                arrO = o - 1;
                arrP = p - 3;
            
                var int1 = roadRoute[o];
                var int2 = roadRoute[p-1];
                directions.push(chalk.bgWhite.cyan('STOP \(' + o + '\):') + '[' + int1 + ']');
                directions.push(chalk.bgCyan.white('STOP \(' + p + '\):') + '[' + int2 + ']');
            }
       
       

            var d = 0;
            directions.forEach(dir => {
                d++;
            });
            directions.splice(send.map_route.length - 1, d);
            d = 0;
            //console.log(send.map_route.length - 2);
            var calcTime = send.map_route.length - 2;
            //console.log(calcTime);
            calcTime = calcTime * 750;
            //console.log(calcTime);
            function listStops() {
                var Stops =  directions.forEach(dir => {
                    console.log(directions[d]);
                    d++;
                }); 
             directions.push(chalk.bgCyan.white('START \(' + 0 + '\):') + '[' + roadRoute[0] + ']');
            };


            for(y = 0; y < roadRoute.length; y++) {
                goCaliss(roadRoute[y]);
               
              
            };

       
        
        res.send(send);
    })
});

app.get('/api/geojson', function(req, res) {
        fs.readFile(__dirname + '/data.geojson', 'utf8', function(err, geoJSON) {
            res.send(geoJSON);
        });
    });

    app.listen(port, () => {
        
    
        setTimeout(function() {
        console.log('listening on port ' + port);
                console.log('listening on port ' + port);

        }, 10000);
    });